***; PADD.lsp - Prompts for a contour line: if a polyline is selected,  PADD
***;            sets the current layer to the same layer as the selected pline
***;            sets the ACAD elevation variable to the z-value of its first
***;            vertex.
***;
***; Written by:    Randy Benson
***;                W. R. Benson & Associates, Inc. 
***;                January, 1994
;-----------------------;
;    PADD.LSP v.1.00    ;
;-----------------------;
;
(princ "\nLoading PADD...")
(defun c:PADD (/ en el oldcmd pt rlayer vrtx)
(defun etest ()
  (while 
    (null (setq en (entsel "\nPick contour line to use for elev: ")))
    (princ "\010\010\010\010\010\010\010\010\010\010\010\010\010\010\010\010")
    (princ "\010\010\010\010\010\010\010\010\010\010\010\010\010\010\010\010")
    (princ "\010\010\010")
    (princ "Missed... Try again:               ")
  )
  (ptest)
)
(defun ptest () 
 (setq en (entget (car en)))
  (if (not (equal "POLYLINE" (cdr (assoc 0 en))))
    (progn
      (princ "\010\010\010\010\010\010\010\010\010\010\010\010\010\010\010\010")
      (princ "\010\010\010\010\010\010\010\010\010\010\010\010\010\010\010\010")
      (princ "\010\010\010")
      (princ "Not a polyline... Try again:                 ")
      (setq en nil)
      (etest)
    )
  )
)
  (setq oldcmd (getvar "CMDECHO")
            en nil
  )
  (setvar "CMDECHO" 0)
  (etest)
  (setq rlayer (cdr (assoc 8 en)))
  (command "LAYER" "S" rlayer "")
  (setq vrtx (entnext (cdr (assoc -1 en)))
          el (cadddr (assoc 10 (entget vrtx)))
  )
  (setvar "ELEVATION" el)
  (princ (strcat "<Elev.= " (rtos el 2 5) ">"))
  (princ "\nPolyline ")
  (setq pt (getpoint "From point: "))
  (command "PLINE" pt)
  (setvar "CMDECHO" oldcmd)
(princ)
)
(princ "Loaded.\n")
(princ)
