;*** PEXT.lsp - Prompts for a contour line: if a polyline is selected,  PEXT
;***            sets the current layer to the same layer as the selected pline
;***            & sets the ACAD elevation variable to the z-value of its first
;***            vertex - then starts a polyline from the end nearest the pick
;***            point.
;***
;***  Written by:    Randy Benson
;***                 W. R. Benson & Associates, Inc. 
;***                 January, 1994
;
;-----------------------
;    PEXT.LSP v.1.01    
;-----------------------
;
(princ "\nLoading PEXT - Extends contour polylines...")
(defun c:PEXT ( / ed en etest oldcmd pt ptest rlayer v1 v2)
(defun etest ()
  (while 
    (null (setq pt (entsel "\nPick end of contour line to extend: ")))
    (princ "\010\010\010\010\010\010\010\010\010\010\010\010\010\010\010\010")
    (princ "\010\010\010\010\010\010\010\010\010\010\010\010\010\010\010\010")
    (princ "\010\010\010\010")
    (princ "Missed... Try again:               ")
  )
  (ptest)
)
(defun ptest () 
  (if (not (equal "POLYLINE" (cdr (assoc 0 (entget (car pt))))))
    (progn
      (princ "\010\010\010\010\010\010\010\010\010\010\010\010\010\010\010\010")
      (princ "\010\010\010\010\010\010\010\010\010\010\010\010\010\010\010\010")
      (princ "\010\010\010\010")
      (princ "Not a polyline... Try again:                 ")
      (setq pt nil)
      (etest)
    )
  )
)
  (if (equal 0 (getvar "WORLDUCS"))
      (princ "\nUCS must be world.  Please change and try again.")
    (progn
      (setq oldcmd (getvar "CMDECHO")
                pt nil
      )
      (setvar "CMDECHO" 0)
      (etest)
      (setq en (car pt)
            ed (entget en)
            pt (cadr pt)
            pt (list (car pt) (cadr pt))
            v1 (entnext (cdr (assoc -1 ed)))
            v2 v1
      )  
      (setq rlayer (cdr (assoc 8 ed)))
      (command "LAYER" "S" rlayer "")
      (while (/= "SEQEND" (cdr (assoc 0 (entget (entnext v2)))))
        (setq v2 (entnext v2))
      )
      (if (< (distance pt (cdr (assoc 10 (entget v1))))
             (distance pt (cdr (assoc 10 (entget v2))))
          )
          (command "pline" (cdr (assoc 10 (entget v1))))
          (command "pline" (cdr (assoc 10 (entget v2))))
      )
      (setvar "CMDECHO" oldcmd)
    (princ)
    )
  )
(princ)
)
(princ "Loaded.\n")

